package com.ejie.ab39a.control;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import com.ejie.ab39a.exceptions.ErrorField;
import com.ejie.ab39a.exceptions.ErrorGenericoException;
import com.ejie.ab39a.model.Planificacion;
import com.ejie.ab39a.service.PlanificacionService;
import com.ejie.ab39a.validations.PlanificacionValidator;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * PlanificacionController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/planificacion")

public class PlanificacionController {

	private static final Logger logger = LoggerFactory.getLogger(PlanificacionController.class);

	@Autowired
	private PlanificacionService planificacionService;

	@Autowired
	private PlanificacionValidator planificacionValidation;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param codplanificacion
	 *            Long codigo planificacion
	 * @return Planificacion Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = { "/{codplanificacion}", "/get/{codplanificacion}" }, method = RequestMethod.GET)
	public @ResponseBody Planificacion get(@PathVariable Long codplanificacion) {
		Planificacion planificacion = new Planificacion();
		planificacion.setCodplanificacion(codplanificacion);
		planificacion = this.planificacionService.find(planificacion);
		PlanificacionController.logger.info("[GET - findBy_PK] : Obtener Planificacion por PK");
		return planificacion;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterPlanificacion
	 *            Planificacion Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Planificacion> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Planificacion> getAll(@ModelAttribute Planificacion filterPlanificacion) {
		PlanificacionController.logger.info("[GET - find_ALL] : Obtener Planificacion por filtro");
		return this.planificacionService.findAll(filterPlanificacion, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param planificacion
	 *            Planificacion Bean que contiene la informacion a modificar.
	 * @return Planificacion Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Planificacion edit(@RequestBody Planificacion planificacion) {

		List<ErrorField> errores = this.planificacionValidation.validate(planificacion);
		if (!errores.isEmpty()) {
			throw new ErrorGenericoException(errores);
		}
		Planificacion planificacionAux = this.planificacionService.update(planificacion);
		PlanificacionController.logger.info("[PUT] : Planificacion actualizado correctamente");
		return planificacionAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param planificacion
	 *            Planificacion Bean que contiene la informacion con la que se
	 *            va a crear el nuevo registro.
	 * @return Planificacion Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Planificacion add(@RequestBody Planificacion planificacion) {

		List<ErrorField> errores = this.planificacionValidation.validate(planificacion);
		if (!errores.isEmpty()) {
			throw new ErrorGenericoException(errores);
		}
		Planificacion planificacionAux = this.planificacionService.addAndDelete(planificacion);

		PlanificacionController.logger.info("[POST] : Planificacion insertado correctamente");
		return planificacionAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param codplanificacion
	 *            Long Identificador del objeto que se desea eliminar.
	 * @return Planificacion Bean eliminado.
	 */
	@RequestMapping(value = "/{codplanificacion}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Planificacion remove(@PathVariable Long codplanificacion) {
		Planificacion planificacion = new Planificacion();
		planificacion.setCodplanificacion(codplanificacion);
		this.planificacionService.remove(planificacion);
		PlanificacionController.logger.info("[DELETE] : Planificacion borrado correctamente");
		return planificacion;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		PlanificacionController.logger.info("[GET - View] : planificacion");
		return "planificacion";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterPlanificacion
	 *            Planificacion Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<Planificacion> Dto que contiene el resultado
	 *         del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<Planificacion> filter(
			@RequestJsonBody(param = "filter") Planificacion filterPlanificacion,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		PlanificacionController.logger.info("[POST - filter] : Obtener Planificacions");
		return this.planificacionService.filter(filterPlanificacion, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterPlanificacion
	 *            Planificacion Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(
			@RequestJsonBody(param = "filter") Planificacion filterPlanificacion,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		PlanificacionController.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Planificacions");
		this.planificacionService.removeMultiple(filterPlanificacion, jqGridRequestDto, false);
		PlanificacionController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param codplanificacion
	 *            Long
	 * @return Planificacion Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/getMaxId", method = RequestMethod.GET)
	public @ResponseBody Planificacion getMaxId() {
		Planificacion maxId = this.planificacionService.getMaxId();
		PlanificacionController.logger.info("[GET - findBy_PK] : Obtener Máximo id de la tabla");
		return maxId;
	}

	/**
	 * Devuelve una objeto planificacion con lso años de la planificacion activa
	 *
	 * @return Planificacion Objeto con lso años de inicio y fin de la
	 *         planificacion activa
	 * 
	 */
	@RequestMapping(value = "/getAnioPlanificacion", method = RequestMethod.GET)
	public @ResponseBody Planificacion getAnioPlanificacion() {
		PlanificacionController.logger.info("[GET - find_ALL] : Obtener los años de la planificacion");
		return this.planificacionService.getAnioPlanificacion();
	}
}
